﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;

namespace DataBindingMailMerge
{
    public class ExampleDataContext : INotifyPropertyChanged
    {
        private string xamlString = @"<t:RadDocument xmlns=""http://schemas.microsoft.com/winfx/2006/xaml/presentation"" xmlns:t=""clr-namespace:Telerik.Windows.Documents.Model;assembly=Telerik.Windows.Documents"" xmlns:s=""clr-namespace:Telerik.Windows.Documents.Model.Styles;assembly=Telerik.Windows.Documents"" xmlns:r=""clr-namespace:Telerik.Windows.Documents.Model.Revisions;assembly=Telerik.Windows.Documents"" xmlns:n=""clr-namespace:Telerik.Windows.Documents.Model.Notes;assembly=Telerik.Windows.Documents"" xmlns:th=""clr-namespace:Telerik.Windows.Documents.Model.Themes;assembly=Telerik.Windows.Documents"" version=""1.2"" LayoutMode=""Paged"" LineSpacing=""1.15"" LineSpacingType=""Auto"" ParagraphDefaultSpacingAfter=""12"" ParagraphDefaultSpacingBefore=""0"" SelectedBibliographicStyleName=""\APA.XSL"" StyleName=""defaultDocumentStyle"">
  <t:RadDocument.Captions>
    <t:CaptionDefinition IsDefault=""True"" IsLinkedToHeading=""False"" Label=""Figure"" LinkedHeadingLevel=""0"" NumberingFormat=""Arabic"" SeparatorType=""Hyphen"" />
    <t:CaptionDefinition IsDefault=""True"" IsLinkedToHeading=""False"" Label=""Table"" LinkedHeadingLevel=""0"" NumberingFormat=""Arabic"" SeparatorType=""Hyphen"" />
  </t:RadDocument.Captions>
  <t:RadDocument.ProtectionSettings>
    <t:DocumentProtectionSettings EnableDocumentProtection=""False"" Enforce=""False"" HashingAlgorithm=""None"" HashingSpinCount=""0"" ProtectionMode=""ReadOnly"" />
  </t:RadDocument.ProtectionSettings>
  <t:RadDocument.Styles>
    <s:StyleDefinition DisplayName=""Document Default Style"" IsCustom=""False"" IsDefault=""False"" IsPrimary=""True"" Name=""defaultDocumentStyle"" Type=""Default"">
      <s:StyleDefinition.ParagraphStyle>
        <s:ParagraphProperties LineSpacing=""1.15"" SpacingAfter=""12"" />
      </s:StyleDefinition.ParagraphStyle>
      <s:StyleDefinition.SpanStyle>
        <s:SpanProperties FontFamily=""Verdana"" FontSize=""16"" FontStyle=""Normal"" FontWeight=""Normal"" />
      </s:StyleDefinition.SpanStyle>
    </s:StyleDefinition>
    <s:StyleDefinition DisplayName=""Normal"" IsCustom=""False"" IsDefault=""True"" IsPrimary=""True"" Name=""Normal"" Type=""Paragraph"" />
    <s:StyleDefinition DisplayName=""TableNormal"" IsCustom=""False"" IsDefault=""True"" IsPrimary=""True"" Name=""TableNormal"" Type=""Table"">
      <s:StyleDefinition.TableStyle>
        <s:TableProperties CellPadding=""5,0,5,0"">
          <s:TableProperties.TableLook>
            <t:TableLook />
          </s:TableProperties.TableLook>
        </s:TableProperties>
      </s:StyleDefinition.TableStyle>
    </s:StyleDefinition>
  </t:RadDocument.Styles>
  <t:Section>
    <t:Paragraph>
      <t:Span Text=""Hello "" />
      <t:FieldRangeStart AnnotationID=""1"">
        <t:MergeField DateTimeFormatting="""" DisplayMode=""Code"" GeneralFormatting="""" NumericFormatting="""" PropertyPath=""FullRecipientName"" />
      </t:FieldRangeStart>
      <t:Span Text=""{}{MERGEFIELD FullRecipientName}"" />
      <t:FieldRangeEnd AnnotationID=""1"" />
      <t:Span Text="","" />
    </t:Paragraph>
    <t:Paragraph>
      <t:Span Text=""Thank you for contacting us!"" />
    </t:Paragraph>
    <t:Paragraph>
      <t:Span Text=""We will need some time to process your request. I will contact you as soon as me have more information to share."" />
    </t:Paragraph>
    <t:Paragraph />
    <t:Paragraph>
      <t:Span Text=""Kind regards,"" />
    </t:Paragraph>
    <t:Paragraph>
      <t:FieldRangeStart AnnotationID=""2"">
        <t:MergeField DateTimeFormatting="""" DisplayMode=""Code"" GeneralFormatting="""" NumericFormatting="""" PropertyPath=""SupportOfficerFirstName"" />
      </t:FieldRangeStart>
      <t:Span Text=""{}{MERGEFIELD SupportOfficerFirstName}"" />
      <t:FieldRangeEnd AnnotationID=""2"" />
      <t:Span Text="" "" />
      <t:FieldRangeStart AnnotationID=""3"">
        <t:MergeField DateTimeFormatting="""" DisplayMode=""Code"" GeneralFormatting="""" NumericFormatting="""" PropertyPath=""SupportOfficerLastName"" />
      </t:FieldRangeStart>
      <t:Span Text=""{}{MERGEFIELD SupportOfficerLastName}"" />
      <t:FieldRangeEnd AnnotationID=""3"" />
    </t:Paragraph>
  </t:Section>
</t:RadDocument>";

        public string XamlString
        {
            get
            {
                return xamlString;
            }
            set
            {
                if (xamlString != value)
                {
                    xamlString = value;
                    OnPropertyChanged("XamlString");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public List<MailMessageInfo> MailMessageInfos = new List<MailMessageInfo>()
        {
            new MailMessageInfo()
            {
                SenderFirstName = "Andrew",
                SenderLastName = "Fuller", 
                SenderJobTitle = "Director - Finance",
                SenderAdress = "908 W. Capital Way",
                RecipientFirstName = "Maria",
                RecipientLastName = "Anders",
                SupportOfficerFirstName = "Matti",
                SupportOfficerLastName = "Karttunen"
            }, 

            new MailMessageInfo()
            {
                SenderFirstName = "Nancy",
                SenderLastName = "Davolio", 
                SenderJobTitle = "Sales Representative",
                SenderAdress = "507 - 20th Ave. E.",
                RecipientFirstName = "Antonio",
                RecipientLastName = "Taquería",
                SupportOfficerFirstName = "Paula",
                SupportOfficerLastName = "Parente"
            }, 

            new MailMessageInfo()
            {
                SenderFirstName = "Janet",
                SenderLastName = "Leverling", 
                SenderJobTitle = "Sales Representative",
                SenderAdress = "722 Moss Bay Blvd.",
                RecipientFirstName = "Thomas",
                RecipientLastName = "Hardy",
                SupportOfficerFirstName = "Paula",
                SupportOfficerLastName = "Parente"
            }, 

            new MailMessageInfo()
            {
                SenderFirstName = "Margaret",
                SenderLastName = "Peacock", 
                SenderJobTitle = "Sales Representative",
                SenderAdress = "4110 Old Redmond Rd.",
                RecipientFirstName = "Martín",
                RecipientLastName = "Sommer",
                SupportOfficerFirstName = "Palle",
                SupportOfficerLastName = "Ibsen"
            }, 

            new MailMessageInfo()
            {
                SenderFirstName = "Steven",
                SenderLastName = "Buchanan", 
                SenderJobTitle = "Sales Manager",
                SenderAdress = "14 Garrett Hill",
                RecipientFirstName = "Alice",
                RecipientLastName = "Fletcher",
                SupportOfficerFirstName = "Jonas",
                SupportOfficerLastName = "Bergulfsen"
            },

            new MailMessageInfo()
            {
                SenderFirstName = "Robert",
                SenderLastName = "King", 
                SenderJobTitle = "Sales Representative",
                SenderAdress = "Edgeham Hollow",
                RecipientFirstName = "Anabela",
                RecipientLastName = "Domingues",
                SupportOfficerFirstName = "Carlos",
                SupportOfficerLastName = "Hernández"
            }, 

            new MailMessageInfo()
            {
                SenderFirstName = "Horst",
                SenderLastName = "Kloss", 
                SenderJobTitle = "Inside Sales Coordinator",
                SenderAdress = "4726 - 11th Ave. N.E.",
                RecipientFirstName = "Anne",
                RecipientLastName = "Dodsworth",
                SupportOfficerFirstName = "Sergio",
                SupportOfficerLastName = "Gutiérrez"
            }
        };

        public ExampleDataContext()
        {
        }


    }
}
