﻿using System;
using System.IO;
using System.Linq;
using System.Windows;
using Microsoft.Win32;
using Telerik.Windows.Documents.FormatProviders.OpenXml.Docx;
using Telerik.Windows.Documents.Model;

namespace DataBindingMailMerge
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ExampleDataContext exampleDataContext;

        public MainWindow()
        {
            InitializeComponent();
            exampleDataContext = new ExampleDataContext();

            this.DataContext = exampleDataContext;
            this.radRichTextBox.Document.MailMergeDataSource.ItemsSource = this.exampleDataContext.MailMessageInfos;

            this.radRichTextBox.DocumentChanged += editor_DocumentChanged;
            this.xamlDataProvider.SetupDocument += xamlDataProvider_SetupDocument;
        }

        void xamlDataProvider_SetupDocument(object sender, Telerik.Windows.Documents.FormatProviders.SetupDocumentEventArgs e)
        {
            e.Document.MailMergeDataSource.ItemsSource = this.exampleDataContext.MailMessageInfos;
        }

        void editor_DocumentChanged(object sender, EventArgs e)
        {
            this.radRichTextBox.Document.MailMergeDataSource.ItemsSource = this.exampleDataContext.MailMessageInfos;
        }

        private void mailMergeCurrentRecord_Click(object sender, RoutedEventArgs e)
        {
            RadDocument currentRecordDocument = this.radRichTextBox.MailMergeCurrentRecord();

            DocxFormatProvider provider = new DocxFormatProvider();
            SaveFileDialog saveDialog = new SaveFileDialog();
            saveDialog.DefaultExt = ".docx";
            saveDialog.Filter = "Documents|*.docx";
            bool? dialogResult = saveDialog.ShowDialog();
            if (dialogResult == true)
            {
                using (Stream output = saveDialog.OpenFile())
                {
                    provider.Export(currentRecordDocument, output);
                }
            }
        }
    }
}
